Overview | Modules | Class Hierarchy | Classes | Members

Public Slots | Public Member Functions | Protected Attributes
tlp::GlMainView Class Reference

Provide an abstract view with OpenGl rendering. More...

`#include <GlMainView.h>`

Inheritance diagram for tlp::GlMainView:
[legend]
Collaboration diagram for tlp::GlMainView:
[legend]

List of all members.

## Public Slots

- virtual void draw ()
- virtual void refresh ()
- virtual void hideOverview (bool)
- virtual void displayOverview (bool display)
- virtual void showDialog (QAction *action)

## Public Member Functions

- GlMainView ()
- virtual ~GlMainView ()
- virtual QWidget * construct (QWidget *parent)
- Graph * getGraph ()
- virtual GlMainWidget * getGlMainWidget ()
- virtual void createPicture (const std::string &pictureName, int width=0, int height=0)
- virtual bool createPicture (const std::string &pictureName, int width, int height, bool center, int zoom=1, int xOffset=0, int yOffset=0)
- virtual QImage createPicture (int width, int height, bool center, int zoom=1, int xOffset=0, int yOffset=0)
- virtual void buildContextMenu (QObject *object, QContextMenuEvent *event, QMenu *contextMenu)
- GWOverviewWidget * getOverviewWidget ()
- QAction * getOverviewAction ()

## Protected Attributes

- GlMainWidget * mainWidget
- QDockWidget * overviewDock
- GWOverviewWidget * overviewWidget
- QFrame * overviewFrame
- QMenu * dialogMenu
- QAction * overviewAction

## Detailed Description

Provide an abstract view with OpenGl rendering.

This class provide an abstract view with OpenGl rendering and overview To do this rendering GlMainView class is use

## Constructor & Destructor Documentation

tlp::GlMainView::GlMainView | ( |  | ) |

Basic contructor

virtual tlp::GlMainView::~GlMainView | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void tlp::GlMainView::buildContextMenu | ( | QObject * | object,
|  | QContextMenuEvent * | event,
|  | QMenu * | contextMenu
| ) |  | `[virtual]`

Build context menu for this view

Reimplemented from tlp::AbstractView.

Reimplemented in tlp::NodeLinkDiagramComponent.

virtual QWidget* tlp::GlMainView::construct | ( | QWidget * | parent | ) | `[virtual]`

Construct this view

Warning:
  If your view inherit of GlMainView you must extend construct function and in this new function call GlMainView::construct(QWidget *)

Reimplemented from tlp::AbstractView.

Reimplemented in tlp::NodeLinkDiagramComponent.

virtual void tlp::GlMainView::createPicture | ( | const std::string & | pictureName,
|  | int | width = `0`,
|  | int | height = `0`
| ) |  | `[virtual]`

Take a snapshot of the view and put it in a picture

Deprecated:
  In Tulip 4.x.y this function will be replace by void createPicture(const string &pictureName,int width, int height, bool center, int zoom, int xOffset, int yOffset)

Reimplemented from tlp::View.

virtual bool tlp::GlMainView::createPicture | ( | const std::string & | pictureName,
|  | int | width,
|  | int | height,
|  | bool | center,
|  | int | zoom = `1`,
|  | int | xOffset = `0`,
|  | int | yOffset = `0`
| ) |  | `[virtual]`

Take a snapshot of the view like old createPicture function but we add some parameters

Parameters:

  pictureName | : name of the picture with extension, extension is used to encode the picture
  width | : width of the picture
  height | : height of the picture
  center | : if we do a center view before create picture or use the current zoom and pan
  zoom | : create a picture of a sub part of the view : with zoom=0 : create only one picture with entire view, with zoom=N : the view is cut into 2^N part in width and height
  xOffset | : this parameters is used to know the part of the view to render if zoom!=0 : xOffset must be : 0 <= xOffset < 2^zoom
  yOffset | : this parameters is used to know the part of the view to render if zoom!=0 : yOffset must be : 0 <= yOffset < 2^zoom

Reimplemented from tlp::View.

virtual QImage tlp::GlMainView::createPicture | ( | int | width,
|  | int | height,
|  | bool | center,
|  | int | zoom = `1`,
|  | int | xOffset = `0`,
|  | int | yOffset = `0`
| ) |  | `[virtual]`

Take a snapshot of the view like old createPicture function and return a QImage

Parameters:

  width | : width of the picture
  height | : height of the picture
  center | : if we do a center view before create picture or use the current zoom and pan
  zoom | : create a picture of a sub part of the view : with zoom=0 : create only one picture with entire view, with zoom=N : the view is cut into 2^N part in width and height
  xOffset | : this parameters is used to know the part of the view to render if zoom!=0 : xOffset must be : 0 <= xOffset < 2^zoom
  yOffset | : this parameters is used to know the part of the view to render if zoom!=0 : yOffset must be : 0 <= yOffset < 2^zoom

Reimplemented from tlp::View.

virtual void tlp::GlMainView::displayOverview | ( | bool | display | ) | `[inline, virtual, slot]`

virtual void tlp::GlMainView::draw | ( |  | ) | `[virtual, slot]`

Draw the OpenGl widget

Implements tlp::View.

Reimplemented in tlp::NodeLinkDiagramComponent.

virtual GlMainWidget* tlp::GlMainView::getGlMainWidget | ( |  | ) | `[virtual]`

You can call this function if you want to have the GlMainWidget of this view If this view doesn't use GlMainWidget : this function return NULL This function is use to export a view to a picture

Graph* tlp::GlMainView::getGraph | ( |  | ) | `[virtual]`

get the graph use in this view

Returns:
  the graph use in this view

Implements tlp::View.

QAction* tlp::GlMainView::getOverviewAction | ( |  | ) | `[inline]`

Return QAction of overview use in the context menu

GWOverviewWidget* tlp::GlMainView::getOverviewWidget | ( |  | ) | `[inline]`

Return the overview widget use by this view

virtual void tlp::GlMainView::hideOverview | ( | bool |  | ) | `[virtual, slot]`

Hide the overview

virtual void tlp::GlMainView::refresh | ( |  | ) | `[virtual, slot]`

Refresh the OpenGl widget

Implements tlp::View.

Reimplemented in tlp::NodeLinkDiagramComponent.

virtual void tlp::GlMainView::showDialog | ( | QAction * | action | ) | `[virtual, slot]`

This slot is call when a QAction in dialog sub menu of context menu is toggle

## Member Data Documentation

QMenu* tlp::GlMainView::dialogMenu`[protected]`

GlMainWidget* tlp::GlMainView::mainWidget`[protected]`

QAction* tlp::GlMainView::overviewAction`[protected]`

QDockWidget* tlp::GlMainView::overviewDock`[protected]`

QFrame* tlp::GlMainView::overviewFrame`[protected]`

GWOverviewWidget* tlp::GlMainView::overviewWidget`[protected]`

Tulip Software by LaBRI Visualization Team 2001 - 2012